﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Runtime.Serialization.Json;

namespace SilverlightWithMvc
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
            Loaded += new RoutedEventHandler(Page_Loaded);
        }

        void Page_Loaded(object sender, RoutedEventArgs e)
        {
            WebClient mvc = new WebClient();
            mvc.OpenReadCompleted += new OpenReadCompletedEventHandler(mvc_OpenReadCompleted);
            mvc.OpenReadAsync(new Uri("http://localhost:33828/Category/List"));
        }

        void mvc_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            DataContractJsonSerializer json = new DataContractJsonSerializer(typeof(List<Category>));
            List<Category> cats = (List<Category>)json.ReadObject(e.Result);
            CategoryList.DisplayMemberPath = "CategoryName";
            CategoryListing.DataContext = cats;
        }

        private void CategoryList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (CategoryList.SelectedIndex > -1)
            {
                ProductDetail.Visibility = Visibility.Collapsed;
                // get the selected category id
                Category c = CategoryList.SelectedItem as Category;

                WebClient prods = new WebClient();
                prods.OpenReadCompleted += new OpenReadCompletedEventHandler(prods_OpenReadCompleted);
                prods.OpenReadAsync(new Uri(string.Format("http://localhost:33828/Category/Products/{0}", c.CategoryID.ToString())));
            }
        }

        void prods_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            DataContractJsonSerializer json = new DataContractJsonSerializer(typeof(List<Product>));
            List<Product> prods = (List<Product>)json.ReadObject(e.Result);
            ProductList.DisplayMemberPath = "ProductName";
            ProductList.ItemsSource = prods;
            ProductListings.Visibility = Visibility.Visible;
        }

        private void ProductList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (ProductList.SelectedIndex > -1)
            {
                Product p = ProductList.SelectedItem as Product;
                ProductDetail.DataContext = p;
                ProductDetail.Visibility = Visibility.Visible;
            }
        }
    }

    public class Category
    {
        public int CategoryID { get; set; }
        public string CategoryName { get; set; }
    }

    public class Product
    {
        public int ProductID { get; set; }
        public string ProductName { get; set; }
        public decimal UnitPrice { get; set; }
    }
}